Page MenuHomePhabricator

Transaction should be in the callback stage (not 'cursory')
Closed, ResolvedPublicPRODUCTION ERROR

Description

Error Message

Transaction should be in the callback stage (not 'cursory')

in 1.32.0-wmf.3 /includes/libs/rdbms/loadbalancer/LoadBalancer.php:1398

Stack Trace

#0 /srv/mediawiki/php-1.32.0-wmf.3/includes/libs/rdbms/lbfactory/LBFactory.php(289): Wikimedia\Rdbms\LoadBalancer->runMasterTransactionIdleCallbacks()
#1 [internal function]: Closure$Wikimedia\Rdbms\LBFactory::executePostTransactionCallbacks(Wikimedia\Rdbms\LoadBalancer)
#2 /srv/mediawiki/php-1.32.0-wmf.3/includes/libs/rdbms/lbfactory/LBFactoryMulti.php(428): call_user_func_array(Closure$Wikimedia\Rdbms\LBFactory::executePostTransactionCallbacks;2235, array)
#3 /srv/mediawiki/php-1.32.0-wmf.3/includes/libs/rdbms/lbfactory/LBFactory.php(291): Wikimedia\Rdbms\LBFactoryMulti->forEachLB(Closure$Wikimedia\Rdbms\LBFactory::executePostTransactionCallbacks;2235)
#4 /srv/mediawiki/php-1.32.0-wmf.3/includes/libs/rdbms/lbfactory/LBFactory.php(263): Wikimedia\Rdbms\LBFactory->executePostTransactionCallbacks()
#5 /srv/mediawiki/php-1.32.0-wmf.3/includes/deferred/DeferredUpdates.php(269): Wikimedia\Rdbms\LBFactory->commitMasterChanges(string)
#6 /srv/mediawiki/php-1.32.0-wmf.3/includes/deferred/DeferredUpdates.php(226): DeferredUpdates::runUpdate(AtomicSectionUpdate, Wikimedia\Rdbms\LBFactoryMulti, string, integer)
#7 /srv/mediawiki/php-1.32.0-wmf.3/includes/deferred/DeferredUpdates.php(134): DeferredUpdates::execute(array, string, integer)
#8 /srv/mediawiki/php-1.32.0-wmf.3/includes/MediaWiki.php(907): DeferredUpdates::doUpdates(string)
#9 /srv/mediawiki/php-1.32.0-wmf.3/includes/MediaWiki.php(727): MediaWiki->restInPeace(string, boolean)
#10 [internal function]: Closure$MediaWiki::doPostOutputShutdown()
#11 {main}

Notes

Event Timeline

mmodell created this task.May 9 2018, 8:25 PM
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptMay 9 2018, 8:25 PM
mmodell updated the task description. (Show Details)May 9 2018, 8:25 PM

Change 432295 had a related patch set uploaded (by Aaron Schulz; owner: Aaron Schulz):
[mediawiki/core@master] rdbms: fix LBFactory::commitAll() round handling

https://gerrit.wikimedia.org/r/432295

Change 432297 had a related patch set uploaded (by 20after4; owner: Aaron Schulz):
[mediawiki/core@wmf/1.32.0-wmf.3] rdbms: fix LBFactory::commitAll() round handling

https://gerrit.wikimedia.org/r/432297

Change 432295 merged by jenkins-bot:
[mediawiki/core@master] rdbms: fix LBFactory::commitAll() round handling

https://gerrit.wikimedia.org/r/432295

Change 432297 merged by jenkins-bot:
[mediawiki/core@wmf/1.32.0-wmf.3] rdbms: fix LBFactory::commitAll() round handling

https://gerrit.wikimedia.org/r/432297

Mentioned in SAL (#wikimedia-operations) [2018-05-10T01:16:41Z] <twentyafterfour@tin> Synchronized php-1.32.0-wmf.3/includes/libs/rdbms: sync https://gerrit.wikimedia.org/r/#/c/432297/ refs T194308 T191049 (duration: 01m 24s)

Even after deploying rMWfe6fb64d68f4: rdbms: fix LBFactory::commitAll() round handling, this appears to still be occurring.

I'm not sure if this should block the train or not?

@aaron: if you don't think this should be a blocker feel free to remove it.

mmodell triaged this task as High priority.May 10 2018, 1:36 AM

Change 432337 had a related patch set uploaded (by Aaron Schulz; owner: Aaron Schulz):
[mediawiki/core@master] rdbms: fix callback stage errors in LBFactory::commitMasterChanges

https://gerrit.wikimedia.org/r/432337

Change 432415 had a related patch set uploaded (by 20after4; owner: Aaron Schulz):
[mediawiki/core@wmf/1.32.0-wmf.3] rdbms: fix callback stage errors in LBFactory::commitMasterChanges

https://gerrit.wikimedia.org/r/432415

Change 432337 merged by jenkins-bot:
[mediawiki/core@master] rdbms: fix callback stage errors in LBFactory::commitMasterChanges

https://gerrit.wikimedia.org/r/432337

Change 432415 merged by jenkins-bot:
[mediawiki/core@wmf/1.32.0-wmf.3] rdbms: fix callback stage errors in LBFactory::commitMasterChanges

https://gerrit.wikimedia.org/r/432415

Mentioned in SAL (#wikimedia-operations) [2018-05-10T19:14:51Z] <twentyafterfour@tin> Synchronized php-1.32.0-wmf.3/includes/libs/rdbms/: deploy https://gerrit.wikimedia.org/r/#/c/432415/ refs T194308 (duration: 01m 23s)

Ok I cherry-picked and deployed the latest patch which seems to have resolved the problem (though I need to monitor for a bit longer to be sure)

mmodell closed this task as Resolved.May 10 2018, 7:52 PM
mmodell claimed this task.
Vvjjkkii renamed this task from Transaction should be in the callback stage (not 'cursory') to v9caaaaaaa.Jul 1 2018, 1:10 AM
Vvjjkkii reopened this task as Open.
Vvjjkkii removed mmodell as the assignee of this task.
Vvjjkkii updated the task description. (Show Details)
Vvjjkkii removed subscribers: gerritbot, Aklapper.
CommunityTechBot renamed this task from v9caaaaaaa to Transaction should be in the callback stage (not 'cursory').Jul 2 2018, 1:49 PM
CommunityTechBot closed this task as Resolved.
mmodell changed the subtype of this task from "Task" to "Production Error".Aug 28 2019, 11:09 PM